'Prog. Melody   Melodieklingel mit C-Control Unit
'M. Baudisch 4/99  horace@earthling.net
'init

'symb
define speed 5          'hier kann man die Abspielgeschwindigkeit einstellen
define liedanz 56       'Anzahl der in der Tabelle gespeicherten Lieder
define taste port[1]    'Taster an Digitalport 1 gegen Masse

'vars
define stop byte        'flag Liedende
define liedoffset word  'Start des Liedes in der Tabelle liedtab
define tonval word      'aus tontab ermittelte 'echte' Tonhhe
define liednr word      'Nr. des z. spielenden Liedes (0..liedanz-1)
define tonbyte byte     'Eintrag aus liedtab, enthlt Tonhhe und -dauer
define hoehe byte       'Tonhhe
define laenge byte      'Tonlnge


'proginit
randomize timer         'Zufallsgenerator initalisieren

#mainloop               'Hauptschleife
liednr=rand
liednr=abs(liednr) mod 371 mod liedanz 'Zufallszahl (0..lieanz-1)
slowmode on             'im Ruhezustand Stromverbrauch vermindern
wait (not taste)        'auf Tastendruck warten
slowmode off            'Geschwindigkeit wieder hoch (sonst geht BEEP nicht richtig)
gosub lied              'dann Lied spielen
goto mainloop           'und weiter

#lied 'Subroutine spielt Lied liednr (0..55)
looktab ofsettab , liednr,liedoffset
'aus ofsettab die Startposition des jeweiligen Liedes in liedtab ermitteln
#ton
        looktab melodtab,liedoffset ,tonbyte 'Notenbyte holen
        stop= (tonbyte shr 7) and &H01       'Stopbit ermitteln
        laenge=(tonbyte shr 4) and  &H07     'Tonlnge ermitteln
        hoehe=tonbyte and &H0f               'Tonhhe ermitteln
        if hoehe > 0 then looktab tontab, hoehe-1,tonval
           'wenn Ton und keine Pause->'echte' Tonhhe aus Tontab holen
        if hoehe=0 then pause (laenge+1)*speed else beep tonval,(laenge+1)*speed ,0
           'Pause oder Ton 'spielen'
        liedoffset=liedoffset+1 ' Offset auf nchstes Tonbyte
if stop =0 then goto ton else return 'nchster Ton oder Liedende

table melodtab "melodtab.tab" 'enthlt die Tonbytes
table ofsettab "ofsettab.tab" 'Offsets der Liedanfnge
table tontab   "ton.tab"      'Tonhhen werden Werte fr BEEP zugeordnet

'Aufbau eines Liedbytes:

'Bit
'7  6  5  4  3  2  1  0
'|  |__|__|  |__|__|__|_ Tonhhe ( 1..15 (G..B') incl. aller Halbtonschritte
'|     |                 wenn 0, kein Ton sondern Pause
'|     |
'|     |________________ Tonlnge in Achtelnoten
'|
'|______________________ Stop-Bit

'Grundidee und Tonformat von Steffen Lehmann 'Eine Melodieklingel mit vielen Melodien'
'(eine Schaltung mit einem Z80)
'Zeitschrift 'Funkamateur' 4/86 S. 203

'wenn der Piepser des Applicationboard zu leise ist -> so wird es 'richtig' laut ;-)
'Beschaltung Beep-Port:
'                      o     + 5V,  Achtung!!! entsprechend 'starkes' Netzteil verwenden
'                      |
'                     ___ /
'                    |   |
'                    |___|    8 Ohm
'                      |  \
'                      _
'                     | | 10 Ohm
'                     |_|
'    470  Ohm          |
'    ____              /
'o--|____|------------|
'                      \>    BC 137 o. .
'Beep-Port               |
'                       _|_
